Summary: Secure Sockets Layer communications libs & utils
Summary(ru):     Secure Sockets Layer communications
%define version 0.9.0b
%define name SSLeay
Name: %{name}
Version: %{version}.KSI2
Release: 5
Source0: ftp://ftp.psy.uq.oz.au/pub/Crypto/SSL/SSLeay-%{version}.tar.gz
Source1: ftp://ftp.psy.uq.oz.au/pub/Crypto/SSL/ssleay-doc-0.tgz
Source2: ftp://ftp.psy.uq.oz.au/pub/Crypto/SSL/SSLeay.doc-1.5.tar.gz
Patch0: SSLeay-0.9.0.patch
Patch1: SSLeay-0.9.0.nolocal.patch
Patch2: SSLeay-0.9.0-include.nolocal.patch
Copyright: Freely distributable
Group: Development/Libraries
Group(ru):  /
URL: http://www.replay.com/redhat/
Icon: ssleay.gif
Obsoletes: libdes
Exclusivearch: i586 i686 i786
Provides: SSL
Prereq: /sbin/ldconfig, sh-utils
Packager: Khimenko Victor <khim@sch57.msk.ru>
Vendor: KSI
Distribution: Nostromo
BuildRoot: /tmp/build-%{name}

%changelog
* Thu Oct 29 1998 Khimenko Victor <khim@sch57.msk.ru>

- i686-optimised des fixes...

* Tue Oct 27 1998 Khimenko Victor <khim@sch57.msk.ru>

- ca.c fixed; more fast version of blowfish and des on PentiumPro/PentiumII

* Wed Aug 19 1998 Khimenko Victor <khim@sch57.msk.ru>

- shortcuts cast & cast-cbc for cast5-cbc removed (cast is used in glimpse)
  use full name

* Mon Aug 17 1998 Serguei Koubouchine <ksi@gu.net>

-   .spec ( Obsoletes, Prereq, Vendor, Distribution).
-      KSI Linux 2.0 (Nostromo) beta.

* Sun Aug 16 1998 Khimenko Victor <khim@sch57.msk.ru>

- Adopted for KSI-Linux 2.0

* Sat Aug  8 1998 Khimenko Victor <khim@sch57.msk.ru>

- shared library creating process honours $RPM_OPT_FLAGS
- shared libarry supports threads (as well as static library)

* Wed Jul 22 1998 Khimenko Victor <khim@sch57.msk.ru>

- building of shared library completely reworked

* Tue Jul 21 1998 Khimenko Victor <khim@sch57.msk.ru>

- RPM is BuildRoot'ed

* Tue Feb 10 1998 Khimenko Victor <khim@sch57.msk.ru>

- all stuff is moved out of /usr/local

%description
A C library that provides various cryptographic algorithms and protocols,
including DES, RC4, RSA, SSL and TLS.  Includes shared libraries and utils.
The SSLeay Crypto FAQ is at: http://www.psy.uq.oz.au/~ftp/Crypto
Goto the webpage indicated by this rpm's URL for access to some
crypto-enabled applications for redhat linux.

%description -l ru
 C,     
 ,   DES, RC4, RSA, SSL  TLS.  
  .

SSLeay Crypto FAQ    http://www.psy.uq.oz.au/~ftp/Crypto.

%package devel
Summary: Secure Sockets Layer communications static libs & headers & utils
Summary(su):  ,     Secure Sockets LayerGroup: Development/Libraries
Group: Development/Libraries
Group(ru):  /
Requires: SSLeay

%description devel
A C library that provides various cryptographic algorithms and protocols,
including DES, RC4, RSA, SSL and TLS. Includes Static libraries and headers
for development. Patches for many networking apps can be found at:
ftp://ftp.psy.uq.oz.au/pub/Crypto/SSLapps/

%description devel -l ru
 C,     
 ,   DES, RC4, RSA, SSL  TLS.  
        SSL.
        
ftp://ftp.psy.uq.oz.au/pub/Crypto/SSLapps/.

%prep
%setup -n SSLeay-%{version} -T -b 0
%patch0 -p1
%setup -T -D -n SSLeay-0.9.0b/doc/html -c -a 1
%setup -T -D -n SSLeay-0.9.0b/doc/ref -c -a 2
#change the named directory back to what it should be
%setup -T -D -n SSLeay-0.9.0b
perl util/perlpath.pl /usr/bin
util/ssldir.pl \$\(RPM_BUILD_ROOT\)/var/lib/ssl
%patch1 -p1

%build 
make -f Makefile.ssl links
CFLAGS="$RPM_OPT_FLAGS -D_REENTRANT -DTHREADS" ./Configure linux-elf
make clean
make depend

#make the shared libraries
RPM_OPT_FLAGS="$RPM_OPT_FLAGS -D_REENTRANT -DTHREADS" sh shlib/linux.sh

#now we can make the other stuff, and they will be linked to the 
#shared libraries
make
LD_LIBRARY_PATH=`pwd` make rehash

%install
mkdir -p $RPM_BUILD_ROOT/etc
mkdir -p $RPM_BUILD_ROOT/usr/bin
mkdir -p $RPM_BUILD_ROOT/usr/include/ssl
mkdir -p $RPM_BUILD_ROOT/usr/lib
RPM_BUILD_ROOT=$RPM_BUILD_ROOT make install
# cast confilicts with glimpse and in fact is only shortcut for cast5-cbc
# use full name
rm -f $RPM_BUILD_ROOT/usr/bin/cast
rm -f $RPM_BUILD_ROOT/usr/bin/cast-cbc

major="0"
minor="9.0"

strip $RPM_BUILD_ROOT/var/lib/ssl/bin/ssleay

install -m644 rsaref/rsaref.h $RPM_BUILD_ROOT/var/lib/ssl/include

mv -f $RPM_BUILD_ROOT/var/lib/ssl/lib/libssl.a $RPM_BUILD_ROOT/usr/lib
install -m644 libssl.so.$major.$minor $RPM_BUILD_ROOT/usr/lib
ln -sf libssl.so.$major.$minor $RPM_BUILD_ROOT/usr/lib/libssl.so

mv -f $RPM_BUILD_ROOT/var/lib/ssl/lib/libcrypto.a $RPM_BUILD_ROOT/usr/lib
install -m644 libcrypto.so.$major.$minor $RPM_BUILD_ROOT/usr/lib
ln -sf libcrypto.so.$major.$minor $RPM_BUILD_ROOT/usr/lib/libcrypto.so

#RSAglue is for inside the US
install -m644 libRSAglue.a $RPM_BUILD_ROOT/usr/lib

cd $RPM_BUILD_ROOT/var/lib/ssl/include
patch -p1 < $RPM_SOURCE_DIR/SSLeay-0.9.0-include.nolocal.patch

mv -f $RPM_BUILD_ROOT/var/lib/ssl/lib/ssleay.cnf $RPM_BUILD_ROOT/etc

mv -f $RPM_BUILD_ROOT/var/lib/ssl/bin/* $RPM_BUILD_ROOT/usr/bin

mv -f $RPM_BUILD_ROOT/var/lib/ssl/include/* $RPM_BUILD_ROOT/usr/include/ssl

/sbin/ldconfig -n $RPM_BUILD_ROOT/usr/lib

%pre devel
# Remove symlink left by SSLeay from KSI Linux 1.2 (Tornado)
if [ -L /usr/include/ssl ]; then
	rm -f /usr/include/ssl
fi

%post
# Remove old directory left by SSLeay from KSI Linux 1.2 (Tornado)
if [ -d /usr/lib/ssl ]; then
	rm -rf /usr/lib/ssl
fi
/sbin/ldconfig

%postun
/sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files 
%doc -P COPYRIGHT PROBLEMS README doc/API.doc doc/a_verify.doc doc/apps.doc doc/ca.1 doc/legal.doc doc/ms3-ca.doc doc/ns-ca.doc doc/readme doc/ref.doc doc/req.1 doc/s_mult.doc doc/ssl-ciph.doc 
%config /etc/ssleay.cnf 
/usr/bin/*
/usr/lib/libcrypto.so.0.*
/usr/lib/libssl.so.*
%dir /var/lib/ssl
/var/lib/ssl/private
/var/lib/ssl/certs

%files devel
%doc -P COPYRIGHT HISTORY HISTORY.066 INSTALL PROBLEMS README README.066 README.080 README.090 TODO VERSION 
%doc -P doc/*.doc doc/readme doc/ref doc/html
%doc -P demos bugs times test test
/usr/lib/libcrypto.a
/usr/lib/libssl.a
/usr/lib/libcrypto.so
/usr/lib/libssl.so
#RSAref is for inside the US
/usr/lib/libRSAglue.a
%dir /usr/include/ssl
/usr/include/ssl/*



